Classes
Protocols
Constants
Functions
Macros
Types
Variables

### Classes

EOAccessArrayFaultHandler
EOAccessFaultHandler
EOAccessGenericFaultHandler
EOAdaptor
EOAdaptorChannel
EOAdaptorContext
EOAdaptorOperation
EOAttribute
EODatabase
EODatabaseChannel
EODatabaseContext
EODatabaseDataSource
EODatabaseOperation
EOEntity
EOEntityClassDescription
EOJoin
EOLoginPanel
EOModel
EOModelGroup
EORelationship
EOSQLExpression
EOSQLExpressionFactory
EOSQLQualifier
EOStoredProcedure

### Protocols

<EOColumnTypes>
<EOPropertyListEncoding>
<EOQualifierSQLGeneration>
(EOAdaptorChannelDelegation)
(EOAdaptorContextDelegation)
(EOAdaptorDelegate)
(EODatabaseContextDelegation)
(EOModelGroupClassDelegation)
(EOModelGroupDelegation)
(EOSchemaSynchronizationDelegates)

### Constants

### Functions

EODatabaseContext_globalIDForObjectWithImpPtr
EODatabaseContext_snapshotForGlobalIDWithImpPtr
GDL2_EOAccessPrivateInit

### Macros

### Types

EOAdaptorOperator
EODatabaseOperator
EODelegateResponse
EOJoinSemantic
EOUpdateStrategy

### Variables

EOAccessFaultObjectNotAvailableException
EOAdaptorContextBeginTransactionNotification
EOAdaptorContextCommitTransactionNotification
EOAdaptorContextRollbackTransactionNotification
EOAdaptorFailureKey
EOAdaptorKey
EOAdaptorOperationsKey
EOAdaptorOptimisticLockingFailure
EOAdministrativeConnectionDictionaryKey
EOAdministrativeConnectionDictionaryNeededNotification
EOAllowsNullKey
EOBindVariableAttributeKey
EOBindVariableColumnKey
EOBindVariableNameKey
EOBindVariablePlaceHolderKey
EOBindVariableValueKey
EOColumnNameKey
EOConnectionDictionaryKey
EOCreateDatabaseKey
EOCreatePrimaryKeySupportKey
EOCreateTablesKey
EOCustomQueryExpressionHintKey
EODatabaseChannelNeededNotification
EODatabaseContextKey
EODatabaseOperationsKey
EODeleteProcedureOperation
EODistantPastTimeInterval
EODropDatabaseKey
EODropPrimaryKeySupportKey
EODropTablesKey
EOEntityLoadedNotification
EOExternalNameKey
EOExternalTypeKey
EOFailedAdaptorOperationKey
EOFailedDatabaseOperationKey
EOFetchAllProcedureOperation
EOFetchWithPrimaryKeyProcedureOperation
EOForeignKeyConstraintsKey
EOGeneralAdaptorException
EOGeneralDatabaseException
EOInsertProcedureOperation
EOModelAddedNotification
EOModelInvalidatedNotification
EOModelKey
EOMoreThanOneException
EONameKey
EONextPrimaryKeyProcedureOperation
EOPrecisionKey
EOPrimaryKeyConstraintsKey
EORelationshipsKey
EOScaleKey
EOSchemaSynchronizationForeignKeyConstraintsKey
EOSchemaSynchronizationPrimaryKeyConstraintsKey
EOSchemaSynchronizationPrimaryKeySupportKey
EOStoredProcedureNameHintKey
EOWidthKey
GDL2_EOAttributeClass
GDL2_EODatabaseContextClass
GDL2_EODatabaseContext__globalIDForObjectIMP
GDL2_EODatabaseContext_snapshotForGlobalIDIMP
GDL2_EOEntityClass
GDL2_EORelationshipClass
eqSel
struct _EOTransactionScope

Up

# EOSQLExpression Class

### Authors

Mirko Viviani (`mirko.viviani@gmail.com`)
Manuel Guesdon (`mguesdon@orange-concept.com`)

Date: Generated at 2026-02-03 22:13:20 +0000

Copyright: (C) 2000-2002,2003,2004,2005 Free Software Foundation, Inc.

### Contents -

1. Software documentation for the EOSQLExpression class
2. Software documentation for the NSNumber(EOSQLFormatting) category
3. Software documentation for the NSString(EOSQLFormatting) category
4. EOSQLExpression variables

# Software documentation for the EOSQLExpression class

## EOSQLExpression : NSObject

> Declared in:
>   EOAccess/EOSQLExpression.h

Description forthcoming.

Instance Variables

### Method summary

- +appendExpression:toScript:
- +createDatabaseStatementsForConnectionDictionary:administrativeConnectionDictionary:
- +createTableStatementsForEntityGroup:
- +createTableStatementsForEntityGroups:
- +dropDatabaseStatementsForConnectionDictionary:administrativeConnectionDictionary:
- +dropPrimaryKeySupportStatementsForEntityGroup:
- +dropPrimaryKeySupportStatementsForEntityGroups:
- +dropTableStatementsForEntityGroup:
- +dropTableStatementsForEntityGroups:
- +foreignKeyConstraintStatementsForRelationship:
- +primaryKeyConstraintStatementsForEntityGroup:
- +primaryKeyConstraintStatementsForEntityGroups:
- +primaryKeySupportStatementsForEntityGroup:
- +primaryKeySupportStatementsForEntityGroups:
- +schemaCreationScriptForEntities:options:
- +schemaCreationStatementsForEntities:options:
- +selectStatementForContainerOptions
- -addCreateClauseForAttribute:
- -allowsNullClauseForConstraint:
- -columnTypeStringForAttribute:
- -prepareConstraintStatementForRelationship:sourceColumns:destinationColumns:
- +isCaseSensitive
- +isColumnType:equivalentToColumnType:options:
- +logicalErrorsInChangeDictionary:forModel:options:
- +phraseCastingColumnNamed:fromType:toType:options:
- +schemaSynchronizationDelegate
- +setSchemaSynchronizationDelegate:
- +statementsToConvertColumnNamed:inTableNamed:fromType:toType:options:
- +statementsToCopyTableNamed:intoTableForEntityGroup:withChangeDictionary:options:
- +statementsToDeleteColumnNamed:inTableNamed:options:
- +statementsToDropForeignKeyConstraintsOnEntityGroups:withChangeDictionary:options:
- +statementsToDropPrimaryKeyConstraintsOnEntityGroups:withChangeDictionary:options:
- +statementsToDropPrimaryKeySupportForEntityGroups:withChangeDictionary:options:
- +statementsToImplementForeignKeyConstraintsOnEntityGroups:withChangeDictionary:options:
- +statementsToImplementPrimaryKeyConstraintsOnEntityGroups:withChangeDictionary:options:
- +statementsToImplementPrimaryKeySupportForEntityGroups:withChangeDictionary:options:
- +statementsToInsertColumnForAttribute:options:
- +statementsToModifyColumnNamed:inTableNamed:toNullRule:options:
- +statementsToRenameColumnNamed:inTableNamed:newName:options:
- +statementsToRenameTableNamed:newName:options:
- +statementsToUpdateObjectStoreForEntityGroups:withChangeDictionary:options:
- +statementsToUpdateObjectStoreForModel:withChangeDictionary:options:
- +supportsDirectColumnCoercion
- +supportsDirectColumnDeletion
- +supportsDirectColumnInsertion
- +supportsDirectColumnNullRuleModification
- +supportsDirectColumnRenaming
- +supportsSchemaSynchronization
- +deleteStatementWithQualifier:entity:
- +expressionForString:
- +formatSQLString:format:
- +formatStringValue:
- +formatValue:forAttribute:
- +insertStatementForRow:entity:
- +selectStatementForAttributes:lock:fetchSpecification:entity:
- +setUseBindVariables:
- +setUseQuotedExternalNames:
- +sqlExpressionWithEntity:
- +sqlPatternFromShellPattern:
- +sqlPatternFromShellPattern:withEscapeCharacter:
- +updateStatementForRow:qualifier:entity:
- +useBindVariables
- +useQuotedExternalNames
- -addBindVariableDictionary:
- -addInsertListAttribute:value:
- -addJoinClauseWithLeftName:rightName:joinSemantic:
- -addOrderByAttributeOrdering:
- -addSelectListAttribute:
- -addUpdateListAttribute:value:
- -aliasesByRelationshipPath
- -appendItem:toListString:
- -assembleDeleteStatementWithQualifier:tableList:whereClause:
- -assembleInsertStatementWithRow:tableList:columnList:valueList:
- -assembleJoinClauseWithLeftName:rightName:joinSemantic:
- -assembleSelectStatementWithAttributes:lock:qualifier:fetchOrder:selectString:columnList:tableList:whereClause:joinClause:orderByClause:lockClause:
- -assembleUpdateStatementWithRow:qualifier:tableList:updateList:whereClause:
- -bindVariableDictionaries
- -bindVariableDictionaryForAttribute:value:
- -entity
- -externalNameQuoteCharacter
- -initWithEntity:
- -joinClauseString
- -joinExpression
- -listString
- -lockClause
- -mustUseBindVariableForAttribute:
- -orderByString
- -prepareDeleteExpressionForQualifier:
- -prepareInsertExpressionWithRow:
- -prepareSelectExpressionWithAttributes:lock:fetchSpecification:
- -prepareUpdateExpressionWithRow:qualifier:
- -setStatement:
- -setUseAliases:
- -shouldUseBindVariableForAttribute:
- -sqlStringForAttribute:
- -sqlStringForAttributeNamed:
- -sqlStringForAttributePath:
- -sqlStringForConjoinedQualifiers:
- -sqlStringForDisjoinedQualifiers:
- -sqlStringForKeyComparisonQualifier:
- -sqlStringForKeyValueQualifier:
- -sqlStringForNegatedQualifier:
- -sqlStringForSchemaObjectName:
- -sqlStringForSelector:value:
- -sqlStringForValue:attributeNamed:
- -sqlStringForValue:caseInsensitiveLikeKey:
- -statement
- -tableListWithRootEntity:
- -useAliases
- -valueList
- -whereClauseString

### deleteStatementWithQualifier: entity:

+ (EOSQLExpression*) deleteStatementWithQualifier: (EOQualifier*)qualifier entity: (EOEntity*)entity;
Description forthcoming.

### expressionForString:

+ (EOSQLExpression*) expressionForString: (NSString*)string;
Description forthcoming.

### formatSQLString: format:

+ (NSString*) formatSQLString: (NSString*)sqlString format: (NSString*)format;
Description forthcoming.

### formatStringValue:

+ (NSString*) formatStringValue: (NSString*)string;
Description forthcoming.

### formatValue: forAttribute:

+ (NSString*) formatValue: (id)value forAttribute: (EOAttribute*)attribute;
Description forthcoming.

### insertStatementForRow: entity:

+ (EOSQLExpression*) insertStatementForRow: (NSDictionary*)row entity: (EOEntity*)entity;
Description forthcoming.

### selectStatementForAttributes: lock: fetchSpecification: entity:

+ (EOSQLExpression*) selectStatementForAttributes: (NSArray*)attributes lock: (BOOL)flag fetchSpecification: (EOFetchSpecification*)fetchSpecification entity: (EOEntity*)entity;
Description forthcoming.

### setUseBindVariables:

+ (void) setUseBindVariables: (BOOL)flag;
Description forthcoming.

### setUseQuotedExternalNames:

+ (void) setUseQuotedExternalNames: (BOOL)flag;
Description forthcoming.

### sqlExpressionWithEntity:

+ (id) sqlExpressionWithEntity: (EOEntity*)entity;
Description forthcoming.

### sqlPatternFromShellPattern:

+ (NSString*) sqlPatternFromShellPattern: (NSString*)pattern;
Description forthcoming.

### sqlPatternFromShellPattern: withEscapeCharacter:

+ (NSString*) sqlPatternFromShellPattern: (NSString*)pattern withEscapeCharacter: (unichar)escapeCharacter;
Description forthcoming.

### updateStatementForRow: qualifier: entity:

+ (EOSQLExpression*) updateStatementForRow: (NSDictionary*)row qualifier: (EOQualifier*)qualifier entity: (EOEntity*)entity;
Description forthcoming.

### useBindVariables

+ (BOOL) useBindVariables;
Description forthcoming.

### useQuotedExternalNames

+ (BOOL) useQuotedExternalNames;
Description forthcoming.

### addBindVariableDictionary:

- (void) addBindVariableDictionary: (NSMutableDictionary*)binding;
Description forthcoming.

### addInsertListAttribute: value:

- (void) addInsertListAttribute: (EOAttribute*)attribute value: (NSString*)value;
Description forthcoming.

### addJoinClauseWithLeftName: rightName: joinSemantic:

- (void) addJoinClauseWithLeftName: (NSString*)leftName rightName: (NSString*)rightName joinSemantic: (EOJoinSemantic)semantic;
Description forthcoming.

### addOrderByAttributeOrdering:

- (void) addOrderByAttributeOrdering: (EOSortOrdering*)sortOrdering;
Description forthcoming.

### addSelectListAttribute:

- (void) addSelectListAttribute: (EOAttribute*)attribute;
Description forthcoming.

### addUpdateListAttribute: value:

- (void) addUpdateListAttribute: (EOAttribute*)attribute value: (NSString*)value;
Description forthcoming.

### aliasesByRelationshipPath

- (NSMutableDictionary*) aliasesByRelationshipPath;
Description forthcoming.

### appendItem: toListString:

- (void) appendItem: (NSString*)itemString toListString: (NSMutableString*)listString;
Description forthcoming.

### assembleDeleteStatementWithQualifier: tableList: whereClause:

- (NSString*) assembleDeleteStatementWithQualifier: (EOQualifier*)qualifier tableList: (NSString*)tableList whereClause: (NSString*)whereClause;
Description forthcoming.

### assembleInsertStatementWithRow: tableList: columnList: valueList:

- (NSString*) assembleInsertStatementWithRow: (NSDictionary*)row tableList: (NSString*)tableList columnList: (NSString*)columnList valueList: (NSString*)valueList;
Description forthcoming.

### assembleJoinClauseWithLeftName: rightName: joinSemantic:

- (NSString*) assembleJoinClauseWithLeftName: (NSString*)leftName rightName: (NSString*)rightName joinSemantic: (EOJoinSemantic)semantic;
Description forthcoming.

### assembleSelectStatementWithAttributes: lock: qualifier: fetchOrder: selectString: columnList: tableList: whereClause: joinClause: orderByClause: lockClause:

- (NSString*) assembleSelectStatementWithAttributes: (NSArray*)attributes lock: (BOOL)lock qualifier: (EOQualifier*)qualifier fetchOrder: (NSArray*)fetchOrder selectString: (NSString*)selectString columnList: (NSString*)columnList tableList: (NSString*)tableList whereClause: (NSString*)whereClause joinClause: (NSString*)joinClause orderByClause: (NSString*)orderByClause lockClause: (NSString*)lockClause;
Description forthcoming.

### assembleUpdateStatementWithRow: qualifier: tableList: updateList: whereClause:

- (NSString*) assembleUpdateStatementWithRow: (NSDictionary*)row qualifier: (EOQualifier*)qualifier tableList: (NSString*)tableList updateList: (NSString*)updateList whereClause: (NSString*)whereClause;
Description forthcoming.

### bindVariableDictionaries

- (NSArray*) bindVariableDictionaries;
Description forthcoming.

### bindVariableDictionaryForAttribute: value:

- (NSMutableDictionary*) bindVariableDictionaryForAttribute: (EOAttribute*)attribute value: (id)value;
Description forthcoming.

### entity

- (EOEntity*) entity;
Description forthcoming.

### externalNameQuoteCharacter

- (NSString*) externalNameQuoteCharacter;
Description forthcoming.

### initWithEntity:

- (id) initWithEntity: (EOEntity*)entity;
Description forthcoming.

### joinClauseString

- (NSMutableString*) joinClauseString;
Description forthcoming.

### joinExpression

- (void) joinExpression;
Build join expression for all used relationships (call this) after all other query parts construction)

### listString

- (NSMutableString*) listString;
Description forthcoming.

### lockClause

- (NSString*) lockClause;
Description forthcoming.

### mustUseBindVariableForAttribute:

- (BOOL) mustUseBindVariableForAttribute: (EOAttribute*)att;
Description forthcoming.

### orderByString

- (NSMutableString*) orderByString;
Description forthcoming.

### prepareDeleteExpressionForQualifier:

- (void) prepareDeleteExpressionForQualifier: (EOQualifier*)qualifier;
Description forthcoming.

### prepareInsertExpressionWithRow:

- (void) prepareInsertExpressionWithRow: (NSDictionary*)row;
Description forthcoming.

### prepareSelectExpressionWithAttributes: lock: fetchSpecification:

- (void) prepareSelectExpressionWithAttributes: (NSArray*)attributes lock: (BOOL)flag fetchSpecification: (EOFetchSpecification*)fetchSpecification;
Description forthcoming.

### prepareUpdateExpressionWithRow: qualifier:

- (void) prepareUpdateExpressionWithRow: (NSDictionary*)row qualifier: (EOQualifier*)qualifier;
Description forthcoming.

### setStatement:

- (void) setStatement: (NSString*)statement;
Description forthcoming.

### setUseAliases:

- (void) setUseAliases: (BOOL)useAliases;
Description forthcoming.

### shouldUseBindVariableForAttribute:

- (BOOL) shouldUseBindVariableForAttribute: (EOAttribute*)att;
Description forthcoming.

### sqlStringForAttribute:

- (NSString*) sqlStringForAttribute: (EOAttribute*)attribute;
Description forthcoming.

### sqlStringForAttributeNamed:

- (NSString*) sqlStringForAttributeNamed: (NSString*)name;
Description forthcoming.

### sqlStringForAttributePath:

- (NSString*) sqlStringForAttributePath: (NSArray*)path;
Description forthcoming.

### sqlStringForConjoinedQualifiers:

- (NSString*) sqlStringForConjoinedQualifiers: (NSArray*)qualifiers;
Description forthcoming.

### sqlStringForDisjoinedQualifiers:

- (NSString*) sqlStringForDisjoinedQualifiers: (NSArray*)qualifiers;
Description forthcoming.

### sqlStringForKeyComparisonQualifier:

- (NSString*) sqlStringForKeyComparisonQualifier: (EOKeyComparisonQualifier*)qualifier;
Description forthcoming.

### sqlStringForKeyValueQualifier:

- (NSString*) sqlStringForKeyValueQualifier: (EOKeyValueQualifier*)qualifier;
Description forthcoming.

### sqlStringForNegatedQualifier:

- (NSString*) sqlStringForNegatedQualifier: (EOQualifier*)qualifier;
Description forthcoming.

### sqlStringForSchemaObjectName:

- (NSString*) sqlStringForSchemaObjectName: (NSString*)name;
Description forthcoming.

### sqlStringForSelector: value:

- (NSString*) sqlStringForSelector: (SEL)selector value: (id)value;
Description forthcoming.

### sqlStringForValue: attributeNamed:

- (NSString*) sqlStringForValue: (id)value attributeNamed: (NSString*)attributeName;
Description forthcoming.

### sqlStringForValue: caseInsensitiveLikeKey:

- (NSString*) sqlStringForValue: (NSString*)valueString caseInsensitiveLikeKey: (NSString*)keyString;
Description forthcoming.

### statement

- (NSString*) statement;
Description forthcoming.

### tableListWithRootEntity:

- (NSString*) tableListWithRootEntity: (EOEntity*)entity;
Description forthcoming.

### useAliases

- (BOOL) useAliases;
Description forthcoming.

### valueList

- (NSMutableString*) valueList;
Description forthcoming.

### whereClauseString

- (NSString*) whereClauseString;
Description forthcoming.

## Instance Variables for EOSQLExpression Class

### _aliasesByRelationshipPath

@protected NSMutableDictionary* _aliasesByRelationshipPath;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _bindings

@protected NSMutableArray* _bindings;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _contextStack

@protected NSMutableArray* _contextStack;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _entity

@protected EOEntity* _entity;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _joinClauseString

@protected NSMutableString* _joinClauseString;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _listString

@protected NSMutableString* _listString;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _orderByString

@protected NSMutableString* _orderByString;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _statement

@protected NSString* _statement;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _valueListString

@protected NSMutableString* _valueListString;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _whereClauseString

@protected NSString* _whereClauseString;
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

# Software documentation for the NSNumber(EOSQLFormatting) category

## NSNumber(EOSQLFormatting)

> Declared in:
>   EOAccess/EOSQLExpression.h

Description forthcoming.

### Method summary

- -sqlString

### sqlString

- (NSString*) sqlString;
Description forthcoming.

# Software documentation for the NSString(EOSQLFormatting) category

## NSString(EOSQLFormatting)

> Declared in:
>   EOAccess/EOSQLExpression.h

Description forthcoming.

### Method summary

- -sqlString

### sqlString

- (NSString*) sqlString;
Description forthcoming.

# EOSQLExpression variables

### EOBindVariableAttributeKey

NSString* EOBindVariableAttributeKey;
Description forthcoming.

### EOBindVariableColumnKey

NSString* EOBindVariableColumnKey;
Description forthcoming.

### EOBindVariableNameKey

NSString* EOBindVariableNameKey;
Description forthcoming.

### EOBindVariablePlaceHolderKey

NSString* EOBindVariablePlaceHolderKey;
Description forthcoming.

### EOBindVariableValueKey

NSString* EOBindVariableValueKey;
Description forthcoming.

Up